---
title: Convert Markdown to HTML with Marked
product: Form Library
description: Learn how to enable Markdown support in your SurveyJS surveys and forms using the Marked library. Check out our JavaScript form builder demo to give it a try.
framework: Vanilla JS
source: https://surveyjs.io/form-library/examples/enable-markdown-in-surveys/vanillajs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Convert Markdown to HTML with Marked (Vanilla JS)

<a href="https://marked.js.org/" target="_blank">Marked</a> is a lightweight and extensible JavaScript library for converting Markdown to HTML. This library allows you to add Markdown support to survey JSON schemas. This example shows how to integrate Marked with SurveyJS Form Library.

To enable Markdown support, implement a function that handles the [`onTextMarkdown`](https://surveyjs.io/form-library/documentation/surveymodel#onTextMarkdown) event. The function's second parameter, `options`, has the `text` property that contains a string value with Markdown content. Pass this value to the Marked converter to get HTML markup. Note that the converter wraps the passed Markdown string into an unnecessary paragraph (`<p>` tag). Remove this tag and assign the result to the `options.html` property.

> The Marked library supports HTML tags in the source. However, this feature is considered unsafe because the converter allows any HTML markup to pass through, even if it contains malicious code. To ensure that the resulting HTML markup is safe, it must be processed through a sanitizer. This demo does not use any third-party sanitizer, as the SurveyJS Form Library includes basic sanitizing capabilities. However, these capabilities do not guarantee 100% protection against malicious code injections. We highly recommend using a dedicated sanitizing library in production code.

Markdown provides <a href="https://www.markdownguide.org/cheat-sheet/" target="_blank">rich formatting capabilities</a> that can be extended if required. For example, this demo allows you to specify image sizes next to the image URL in a survey JSON schema. See the code examples for further details.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";
import { marked } from "marked";

// Support specifying image size next to its URL
const renderer = {
  image: function (src, _, alt) {
    src = src.href || src;
    const sizeStr = ',size=';
    let i = src.indexOf(sizeStr);
    let height = '';
    let width = '';
    if (i > -1) {
      let str = src.substring(i + sizeStr.length);
      src = src.substring(0, i);
      i = str.indexOf('x');
      if (i > -1) {
        height = str.substring(0, i) + 'px';
        width = str.substring(i + 1) + 'px';
      }
    }
    let res = '<img src="' + src + '" alt="' + alt;
    if (height) res += '" height="' + height;
    if (width) res += '" width="' + width;
    return res + '">';
  }
};

marked.use({ renderer });
const survey = new Model(json);
survey.onComplete.add((sender, options) => {
    console.log(JSON.stringify(sender.data, null, 3));
});
survey.onTextMarkdown.add((_, options) => {
    // Convert Markdown to HTML
    let str = marked(options.text);
    // ...
    // Sanitize the HTML markup using a third-party library here
    // ...
    // Remove root paragraphs <p></p>
    str = str.substring(3);
    str = str.substring(0, str.length - 5);
    // Set HTML markup to render
    options.html = str;
});

survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "elements": [
    {
      "type": "radiogroup",
      "name": "favoritePet",
      "title": "What is your favorite pet?",
      "choices": [
        {
          "value": "dog",
          "text": "![Dog](https://surveyjs.io/Content/Images/examples/markdown/dog.svg,size=14x14) Dog"
        },
        {
          "value": "cat",
          "text": "![Cat](https://surveyjs.io/Content/Images/examples/markdown/cat.svg,size=14x14) Cat"
        },
        {
          "value": "parrot",
          "text": "![Parrot](https://surveyjs.io/Content/Images/examples/markdown/parrot.svg,size=14x14) Parrot"
        }
      ]
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "marked": "latest",
    "survey-core": "latest",
    "survey-js-ui": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/enable-markdown-in-surveys/angular.md)
- [React](https://surveyjs.io/form-library/examples/enable-markdown-in-surveys/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/enable-markdown-in-surveys/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/enable-markdown-in-surveys/jquery.md)


---
title: Convert Markdown to HTML with Marked
product: Form Library
description: Learn how to enable Markdown support in your SurveyJS surveys and forms using the Marked library. Check out our JavaScript form builder demo to give it a try.
framework: Angular
source: https://surveyjs.io/form-library/examples/enable-markdown-in-surveys/angular
index: https://surveyjs.io/form-library/examples/overview.md
---

# Convert Markdown to HTML with Marked (Angular)

<a href="https://marked.js.org/" target="_blank">Marked</a> is a lightweight and extensible JavaScript library for converting Markdown to HTML. This library allows you to add Markdown support to survey JSON schemas. This example shows how to integrate Marked with SurveyJS Form Library.

To enable Markdown support, implement a function that handles the [`onTextMarkdown`](https://surveyjs.io/form-library/documentation/surveymodel#onTextMarkdown) event. The function's second parameter, `options`, has the `text` property that contains a string value with Markdown content. Pass this value to the Marked converter to get HTML markup. Note that the converter wraps the passed Markdown string into an unnecessary paragraph (`<p>` tag). Remove this tag and assign the result to the `options.html` property.

> The Marked library supports HTML tags in the source. However, this feature is considered unsafe because the converter allows any HTML markup to pass through, even if it contains malicious code. To ensure that the resulting HTML markup is safe, it must be processed through a sanitizer. This demo does not use any third-party sanitizer, as the SurveyJS Form Library includes basic sanitizing capabilities. However, these capabilities do not guarantee 100% protection against malicious code injections. We highly recommend using a dedicated sanitizing library in production code.

Markdown provides <a href="https://www.markdownguide.org/cheat-sheet/" target="_blank">rich formatting capabilities</a> that can be extended if required. For example, this demo allows you to specify image sizes next to the image URL in a survey JSON schema. See the code examples for further details.

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "elements": [
    {
      "type": "radiogroup",
      "name": "favoritePet",
      "title": "What is your favorite pet?",
      "choices": [
        {
          "value": "dog",
          "text": "![Dog](https://surveyjs.io/Content/Images/examples/markdown/dog.svg,size=14x14) Dog"
        },
        {
          "value": "cat",
          "text": "![Cat](https://surveyjs.io/Content/Images/examples/markdown/cat.svg,size=14x14) Cat"
        },
        {
          "value": "parrot",
          "text": "![Parrot](https://surveyjs.io/Content/Images/examples/markdown/parrot.svg,size=14x14) Parrot"
        }
      ]
    }
  ]
};
```

### `src/app/components/survey.component.css`

```css
/* You can add your custom CSS here. */
```

### `src/app/components/survey.component.html`

```html
<survey [model]="model" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; height:100%"></survey>
```

### `src/app/components/survey.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { json } from "./json";
import "./survey.component.css";
import "survey-core/survey-core.min.css";
import { marked } from "marked";

// Support specifying image size next to its URL
const renderer = {
  image: function (src, _, alt) {
    src = src.href || src;
    const sizeStr = ',size=';
    let i = src.indexOf(sizeStr);
    let height = '';
    let width = '';
    if (i > -1) {
      let str = src.substring(i + sizeStr.length);
      src = src.substring(0, i);
      i = str.indexOf('x');
      if (i > -1) {
        height = str.substring(0, i) + 'px';
        width = str.substring(i + 1) + 'px';
      }
    }
    let res = '<img src="' + src + '" alt="' + alt;
    if (height) res += '" height="' + height;
    if (width) res += '" width="' + width;
    return res + '">';
  }
};

marked.use({ renderer });
@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./survey.component.html",
    styleUrls: ["./survey.component.css"]
})
export class SurveyComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.onTextMarkdown.add((_, options) => {
            // Convert Markdown to HTML
            let str = marked(options.text);
            // ...
            // Sanitize the HTML markup using a third-party library here
            // ...
            // Remove root paragraphs <p></p>
            str = str.substring(3);
            str = str.substring(0, str.length - 5);
            // Set HTML markup to render
            options.html = str;
        });
        survey.onComplete.add((sender, options) => {
            console.log(JSON.stringify(sender.data, null, 3));
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyComponent } from "./components/survey.component";

@NgModule({
    declarations: [AppComponent, SurveyComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add your custom CSS here. */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "marked": "latest",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/form-library/examples/enable-markdown-in-surveys/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/enable-markdown-in-surveys/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/enable-markdown-in-surveys/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/enable-markdown-in-surveys/vanillajs.md)


---
title: Convert Markdown to HTML with Marked
product: Form Library
description: Learn how to enable Markdown support in your SurveyJS surveys and forms using the Marked library. Check out our JavaScript form builder demo to give it a try.
framework: React
source: https://surveyjs.io/form-library/examples/enable-markdown-in-surveys/reactjs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Convert Markdown to HTML with Marked (React)

<a href="https://marked.js.org/" target="_blank">Marked</a> is a lightweight and extensible JavaScript library for converting Markdown to HTML. This library allows you to add Markdown support to survey JSON schemas. This example shows how to integrate Marked with SurveyJS Form Library.

To enable Markdown support, implement a function that handles the [`onTextMarkdown`](https://surveyjs.io/form-library/documentation/surveymodel#onTextMarkdown) event. The function's second parameter, `options`, has the `text` property that contains a string value with Markdown content. Pass this value to the Marked converter to get HTML markup. Note that the converter wraps the passed Markdown string into an unnecessary paragraph (`<p>` tag). Remove this tag and assign the result to the `options.html` property.

> The Marked library supports HTML tags in the source. However, this feature is considered unsafe because the converter allows any HTML markup to pass through, even if it contains malicious code. To ensure that the resulting HTML markup is safe, it must be processed through a sanitizer. This demo does not use any third-party sanitizer, as the SurveyJS Form Library includes basic sanitizing capabilities. However, these capabilities do not guarantee 100% protection against malicious code injections. We highly recommend using a dedicated sanitizing library in production code.

Markdown provides <a href="https://www.markdownguide.org/cheat-sheet/" target="_blank">rich formatting capabilities</a> that can be extended if required. For example, this demo allows you to specify image sizes next to the image URL in a survey JSON schema. See the code examples for further details.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/SurveyComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";
import { marked } from "marked";

// Support specifying image size next to its URL
const renderer = {
  image: function (src, _, alt) {
    src = src.href || src;
    const sizeStr = ',size=';
    let i = src.indexOf(sizeStr);
    let height = '';
    let width = '';
    if (i > -1) {
      let str = src.substring(i + sizeStr.length);
      src = src.substring(0, i);
      i = str.indexOf('x');
      if (i > -1) {
        height = str.substring(0, i) + 'px';
        width = str.substring(i + 1) + 'px';
      }
    }
    let res = '<img src="' + src + '" alt="' + alt;
    if (height) res += '" height="' + height;
    if (width) res += '" width="' + width;
    return res + '">';
  }
};

marked.use({ renderer });
function SurveyComponent() {
    const survey = new Model(json);
    survey.onComplete.add((sender, options) => {
        console.log(JSON.stringify(sender.data, null, 3));
    });
    survey.onTextMarkdown.add((_, options) => {
        // Convert Markdown to HTML
        let str = marked(options.text);
        // ...
        // Sanitize the HTML markup using a third-party library here
        // ...
        // Remove root paragraphs <p></p>
        str = str.substring(3);
        str = str.substring(0, str.length - 5);
        // Set HTML markup to render
        options.html = str;
    });
    return (<Survey model={survey} />);
}

export default SurveyComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyComponent from "./SurveyComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyComponent />);
```

### `src/json.js`

```js
export const json = {
  "elements": [
    {
      "type": "radiogroup",
      "name": "favoritePet",
      "title": "What is your favorite pet?",
      "choices": [
        {
          "value": "dog",
          "text": "![Dog](https://surveyjs.io/Content/Images/examples/markdown/dog.svg,size=14x14) Dog"
        },
        {
          "value": "cat",
          "text": "![Cat](https://surveyjs.io/Content/Images/examples/markdown/cat.svg,size=14x14) Cat"
        },
        {
          "value": "parrot",
          "text": "![Parrot](https://surveyjs.io/Content/Images/examples/markdown/parrot.svg,size=14x14) Parrot"
        }
      ]
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "marked": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/enable-markdown-in-surveys/angular.md)
- [Vue 3](https://surveyjs.io/form-library/examples/enable-markdown-in-surveys/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/enable-markdown-in-surveys/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/enable-markdown-in-surveys/vanillajs.md)
